import { BeanDefinition, Loader, XmlFileLoader, JsonFileLoader, RegexFilter, Repository, Service, Component, Controller, Scope, Bean, LoaderOptions, Configuration, ConfigurationProperties, ApplicationContext, ConditionalOnMissingBean, Scheduled, Scheduler, ControllerAdvice, Logger, PostConstruct, PreDestroy, RevaneConfiguration } from 'revane-ioc';
import { All, Get, Post, Param, Params, Patch, Delete, Options, Head, Put, Cookie, Cookies, Query, QueryParameters, Body, Response, RevaneResponse, RevaneRequest, Header, Headers, Log, ErrorHandler, ResponseStatus } from 'revane-fastify';
export declare class Revane {
    private serverCommands;
    private serverOptionCommands;
    private containerCommands;
    private server;
    private container;
    register(id: string | any, options?: any): Revane;
    registerControllers(): Revane;
    setErrorHandler(id: string): Revane;
    setNotFoundHandler(id: string): Revane;
    ready(handler: (err: Error) => void): Revane;
    basePackage(path: string): Revane;
    componentScan(path: string, excludeFilters?: RegexFilter[], includeFilters?: RegexFilter[]): Revane;
    xmlFile(file: string): Revane;
    jsonFile(file: string): Revane;
    noRedefinition(noRedefinition?: boolean): Revane;
    configurationDir(path: string): Revane;
    disableAutoConfiguration(): Revane;
    silent(isSilent: boolean): Revane;
    initialize(): Promise<Revane>;
    getBean(id: string): Promise<any>;
    port(): number;
    tearDown(): Promise<void>;
    private shutdownGracefully;
    private logUncaughtError;
    private disposeCommands;
}
export declare function revane(): Revane;
export { BeanDefinition, Loader, XmlFileLoader, JsonFileLoader, RegexFilter, LoaderOptions, Repository, Service, Component, Controller, ControllerAdvice, Scope, Bean, All, Get, Post, Param, Params, Patch, Delete, Options, Head, Put, Cookie, Cookies, Query, QueryParameters, Body, Response, RevaneResponse, RevaneRequest, Header, Headers, Log, Configuration, ConfigurationProperties, ApplicationContext, ConditionalOnMissingBean, Scheduled, Scheduler, ErrorHandler, ResponseStatus, Logger, PostConstruct, PreDestroy, RevaneConfiguration };
export default Revane;
