"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.RevaneConfiguration = exports.PreDestroy = exports.PostConstruct = exports.Logger = exports.ResponseStatus = exports.ErrorHandler = exports.Scheduler = exports.Scheduled = exports.ConditionalOnMissingBean = exports.ConfigurationProperties = exports.Configuration = exports.Log = exports.Headers = exports.Header = exports.Response = exports.Body = exports.QueryParameters = exports.Query = exports.Cookies = exports.Cookie = exports.Put = exports.Head = exports.Options = exports.Delete = exports.Patch = exports.Params = exports.Param = exports.Post = exports.Get = exports.All = exports.Bean = exports.Scope = exports.ControllerAdvice = exports.Controller = exports.Component = exports.Service = exports.Repository = exports.LoaderOptions = exports.JsonFileLoader = exports.XmlFileLoader = exports.revane = exports.Revane = void 0;
const revane_ioc_1 = require("revane-ioc");
Object.defineProperty(exports, "XmlFileLoader", { enumerable: true, get: function () { return revane_ioc_1.XmlFileLoader; } });
Object.defineProperty(exports, "JsonFileLoader", { enumerable: true, get: function () { return revane_ioc_1.JsonFileLoader; } });
Object.defineProperty(exports, "Repository", { enumerable: true, get: function () { return revane_ioc_1.Repository; } });
Object.defineProperty(exports, "Service", { enumerable: true, get: function () { return revane_ioc_1.Service; } });
Object.defineProperty(exports, "Component", { enumerable: true, get: function () { return revane_ioc_1.Component; } });
Object.defineProperty(exports, "Controller", { enumerable: true, get: function () { return revane_ioc_1.Controller; } });
Object.defineProperty(exports, "Scope", { enumerable: true, get: function () { return revane_ioc_1.Scope; } });
Object.defineProperty(exports, "Bean", { enumerable: true, get: function () { return revane_ioc_1.Bean; } });
Object.defineProperty(exports, "LoaderOptions", { enumerable: true, get: function () { return revane_ioc_1.LoaderOptions; } });
Object.defineProperty(exports, "Configuration", { enumerable: true, get: function () { return revane_ioc_1.Configuration; } });
Object.defineProperty(exports, "ConfigurationProperties", { enumerable: true, get: function () { return revane_ioc_1.ConfigurationProperties; } });
Object.defineProperty(exports, "ConditionalOnMissingBean", { enumerable: true, get: function () { return revane_ioc_1.ConditionalOnMissingBean; } });
Object.defineProperty(exports, "Scheduled", { enumerable: true, get: function () { return revane_ioc_1.Scheduled; } });
Object.defineProperty(exports, "Scheduler", { enumerable: true, get: function () { return revane_ioc_1.Scheduler; } });
Object.defineProperty(exports, "ControllerAdvice", { enumerable: true, get: function () { return revane_ioc_1.ControllerAdvice; } });
Object.defineProperty(exports, "Logger", { enumerable: true, get: function () { return revane_ioc_1.Logger; } });
Object.defineProperty(exports, "PostConstruct", { enumerable: true, get: function () { return revane_ioc_1.PostConstruct; } });
Object.defineProperty(exports, "PreDestroy", { enumerable: true, get: function () { return revane_ioc_1.PreDestroy; } });
Object.defineProperty(exports, "RevaneConfiguration", { enumerable: true, get: function () { return revane_ioc_1.RevaneConfiguration; } });
const RevaneBuilder_1 = require("./RevaneBuilder");
const revane_fastify_1 = require("revane-fastify");
Object.defineProperty(exports, "All", { enumerable: true, get: function () { return revane_fastify_1.All; } });
Object.defineProperty(exports, "Get", { enumerable: true, get: function () { return revane_fastify_1.Get; } });
Object.defineProperty(exports, "Post", { enumerable: true, get: function () { return revane_fastify_1.Post; } });
Object.defineProperty(exports, "Param", { enumerable: true, get: function () { return revane_fastify_1.Param; } });
Object.defineProperty(exports, "Params", { enumerable: true, get: function () { return revane_fastify_1.Params; } });
Object.defineProperty(exports, "Patch", { enumerable: true, get: function () { return revane_fastify_1.Patch; } });
Object.defineProperty(exports, "Delete", { enumerable: true, get: function () { return revane_fastify_1.Delete; } });
Object.defineProperty(exports, "Options", { enumerable: true, get: function () { return revane_fastify_1.Options; } });
Object.defineProperty(exports, "Head", { enumerable: true, get: function () { return revane_fastify_1.Head; } });
Object.defineProperty(exports, "Put", { enumerable: true, get: function () { return revane_fastify_1.Put; } });
Object.defineProperty(exports, "Cookie", { enumerable: true, get: function () { return revane_fastify_1.Cookie; } });
Object.defineProperty(exports, "Cookies", { enumerable: true, get: function () { return revane_fastify_1.Cookies; } });
Object.defineProperty(exports, "Query", { enumerable: true, get: function () { return revane_fastify_1.Query; } });
Object.defineProperty(exports, "QueryParameters", { enumerable: true, get: function () { return revane_fastify_1.QueryParameters; } });
Object.defineProperty(exports, "Body", { enumerable: true, get: function () { return revane_fastify_1.Body; } });
Object.defineProperty(exports, "Response", { enumerable: true, get: function () { return revane_fastify_1.Response; } });
Object.defineProperty(exports, "Header", { enumerable: true, get: function () { return revane_fastify_1.Header; } });
Object.defineProperty(exports, "Headers", { enumerable: true, get: function () { return revane_fastify_1.Headers; } });
Object.defineProperty(exports, "Log", { enumerable: true, get: function () { return revane_fastify_1.Log; } });
Object.defineProperty(exports, "ErrorHandler", { enumerable: true, get: function () { return revane_fastify_1.ErrorHandler; } });
Object.defineProperty(exports, "ResponseStatus", { enumerable: true, get: function () { return revane_fastify_1.ResponseStatus; } });
class Revane {
    constructor() {
        this.serverCommands = [];
        this.serverOptionCommands = [];
        this.containerCommands = [];
    }
    register(id, options) {
        this.serverCommands.push({ type: 'register', args: [id, options] });
        return this;
    }
    registerControllers() {
        this.serverCommands.push({ type: 'registerControllers', args: [] });
        return this;
    }
    setErrorHandler(id) {
        this.serverCommands.push({ type: 'setErrorHandler', args: [id] });
        return this;
    }
    setNotFoundHandler(id) {
        this.serverCommands.push({ type: 'setNotFoundHandler', args: [id] });
        return this;
    }
    ready(handler) {
        this.serverCommands.push({ type: 'ready', args: [handler] });
        return this;
    }
    basePackage(path) {
        this.containerCommands.push({ type: 'basePackage', args: [path] });
        return this;
    }
    componentScan(path, excludeFilters, includeFilters) {
        this.containerCommands.push({
            type: 'componentScan',
            args: [path, excludeFilters, includeFilters]
        });
        return this;
    }
    xmlFile(file) {
        this.containerCommands.push({ type: 'xmlFile', args: [file] });
        return this;
    }
    jsonFile(file) {
        this.containerCommands.push({ type: 'jsonFile', args: [file] });
        return this;
    }
    noRedefinition(noRedefinition) {
        this.containerCommands.push({ type: 'noRedefinition', args: [noRedefinition] });
        return this;
    }
    configurationDir(path) {
        this.containerCommands.push({ type: 'configurationDir', args: [path] });
        return this;
    }
    disableAutoConfiguration() {
        this.containerCommands.push({ type: 'disableAutoConfiguration', args: [] });
        return this;
    }
    silent(isSilent) {
        this.serverOptionCommands.push({ type: 'silent', args: [isSilent] });
        return this;
    }
    async initialize() {
        if (this.serverCommands.filter((command) => command.type === 'registerControllers').length === 0) {
            this.registerControllers();
        }
        const { container, server } = await RevaneBuilder_1.revaneBuilder()
            .container(this.containerCommands)
            .server(this.serverOptionCommands, this.serverCommands)
            .build();
        this.container = container;
        this.server = server;
        process.on('SIGINT', () => this.shutdownGracefully('SIGINT'));
        process.on('SIGTERM', () => this.shutdownGracefully('SIGTERM'));
        process.on('multipleResolves', (type, promise, reason) => this.logUncaughtError('multipleResolves', reason));
        process.on('rejectionHandled', (reason) => this.logUncaughtError('rejectionHandled', reason));
        process.on('uncaughtException', (reason) => this.logUncaughtError('uncaughtException', reason));
        this.disposeCommands();
        return this;
    }
    async getBean(id) {
        return this.container.get(id);
    }
    port() {
        if (this.server) {
            return this.server.port();
        }
        return null;
    }
    async tearDown() {
        if (this.server) {
            await this.server.close();
        }
        await this.container.close();
    }
    async shutdownGracefully(event) {
        if (await this.container.has('logger')) {
            const logger = await this.container.get('logger');
            logger.info(`Received ${event} event. Shutdown in progress...`);
        }
        else {
            console.log(`Received ${event} event. Shutdown in progress...`);
        }
        this.tearDown()
            .then(() => process.exit(0))
            .catch((error) => {
            console.error('Shutdown failed', error);
            process.exit(1);
        });
    }
    async logUncaughtError(event, reason) {
        if (await this.container.has('logger')) {
            const logger = await this.container.get('logger');
            logger.error(`Caught ${event} event:`, reason);
        }
        else {
            console.error(`Caught ${event} event:`, reason);
        }
        this.tearDown()
            .then(() => process.exit(0))
            .catch((error) => {
            console.error('Shutdown failed', error);
            process.exit(1);
        });
    }
    disposeCommands() {
        this.serverCommands = null;
        this.serverOptionCommands = null;
        this.containerCommands = null;
    }
}
exports.Revane = Revane;
function revane() {
    return new Revane();
}
exports.revane = revane;
exports.default = Revane;
