"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.RevaneBuilder = exports.revaneBuilder = void 0;
const ServerBuilder_1 = require("./ServerBuilder");
const ContainerBuilder_1 = require("./ContainerBuilder");
function revaneBuilder() {
    return new RevaneBuilder();
}
exports.revaneBuilder = revaneBuilder;
class RevaneBuilder {
    server(serverOptionCommands, serverCommands) {
        this.serverBuilder = new ServerBuilder_1.ServerBuilder(serverOptionCommands, serverCommands);
        return this;
    }
    container(containerCommands) {
        this.containerBuilder = new ContainerBuilder_1.ContainerBuilder(containerCommands);
        return this;
    }
    async build() {
        const container = await this.containerBuilder.build();
        const server = await this.serverBuilder
            .container(container)
            .build();
        return { container, server };
    }
}
exports.RevaneBuilder = RevaneBuilder;
